from chainmodel.models.steem import Block, Operation, OperationIndex
from chainmodel.models.steem.ops import *
from chainmodel.models.steem.ops.custom_json import *

class Schema():

    models = {
        'block': Block,
        'index': OperationIndex,
        'op': Operation,
        'ops': {
            'account_create_with_delegation': AccountCreateWithDelegation,
            'account_create': AccountCreate,
            'account_update': AccountUpdate,
            'account_witness_proxy': AccountWitnessProxy,
            'account_witness_vote': AccountWitnessVote,
            'author_reward': AuthorReward,
            'cancel_transfer_from_savings': CancelTransferFromSavings,
            'change_recovery_account': ChangeRecoveryAccount,
            'claim_reward_balance': ClaimRewardBalance,
            'comment_benefactor_reward': CommentBenefactorReward,
            'comment_options': CommentOptions,
            'comment': Comment,
            'convert': Convert,
            'curation_reward': CurationReward,
            'custom_json': CustomJSON,
            'custom_json.follow': Follow,
            'custom_json.reblog': Reblog,
            'custom': Custom,
            'decline_voting_rights': DeclineVotingRights,
            'delegate_vesting_shares': DelegateVestingShares,
            'delete_comment': DeleteComment,
            'escrow_approve': EscrowApprove,
            'escrow_dispute': EscrowDispute,
            'escrow_release': EscrowRelease,
            'escrow_transfer': EscrowTransfer,
            'feed_publish': FeedPublish,
            'fill_convert_request': FillConvertRequest,
            'fill_order': FillOrder,
            'fill_transfer_from_savings': FillTransferFromSavings,
            'fill_vesting_withdraw': FillVestingWithdraw,
            'interest': Interest,
            'limit_order_cancel': LimitOrderCancel,
            'limit_order_create': LimitOrderCreate,
            'limit_order_create2': LimitOrderCreate2,
            'liquidity_reward': LiquidityReward,
            'pow': Pow,
            'pow2': Pow2,
            'producer_reward': ProducerReward,
            'recover_account': RecoverAccount,
            'request_account_recovery': RequestAccountRecovery,
            'return_vesting_delegation': ReturnVestingDelegation,
            'set_withdraw_vesting_route': SetWithdrawVestingRoute,
            'shutdown_witness': ShutdownWitness,
            'transfer_from_savings': TransferFromSavings,
            'transfer_to_savings': TransferToSavings,
            'transfer_to_vesting': TransferToVesting,
            'transfer': Transfer,
            'vote': Vote,
            'withdraw_vesting': WithdrawVesting,
            'witness_update': WitnessUpdate,
        }
    }
